VERSION 5.00
Begin VB.Form FConnectDialog 
   BorderStyle     =   4  'Festes Werkzeugfenster
   Caption         =   "Internet connection"
   ClientHeight    =   2595
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   5565
   ClipControls    =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2595
   ScaleWidth      =   5565
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'Fenstermitte
   Begin VB.CheckBox chkFromCache 
      Caption         =   "From Cache"
      Enabled         =   0   'False
      Height          =   285
      Left            =   2880
      TabIndex        =   5
      Top             =   2160
      Width           =   1215
   End
   Begin VB.CheckBox chkAsync 
      Caption         =   "Asynchronous"
      Enabled         =   0   'False
      Height          =   195
      Left            =   1470
      TabIndex        =   4
      Top             =   2190
      Width           =   1365
   End
   Begin VB.TextBox txtBypassProxy 
      Height          =   915
      Left            =   1470
      MultiLine       =   -1  'True
      TabIndex        =   3
      Top             =   1080
      Width           =   2595
   End
   Begin VB.TextBox txtProxy 
      Height          =   285
      Left            =   1470
      TabIndex        =   2
      Top             =   630
      Width           =   2595
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   315
      Left            =   4320
      TabIndex        =   7
      Top             =   630
      Width           =   1095
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   315
      Left            =   4320
      TabIndex        =   6
      Top             =   180
      Width           =   1095
   End
   Begin VB.ComboBox cboAccessType 
      Height          =   315
      Left            =   1470
      Style           =   2  'Dropdown-Liste
      TabIndex        =   1
      Top             =   180
      Width           =   2595
   End
   Begin VB.Label lblFlags 
      Caption         =   "Options:"
      Enabled         =   0   'False
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   2160
      Width           =   1035
   End
   Begin VB.Label lblBypassProxy 
      Caption         =   "Don't use proxy for these hosts:"
      Height          =   495
      Left            =   120
      TabIndex        =   9
      Top             =   1050
      Width           =   1215
   End
   Begin VB.Label lblProxy 
      Caption         =   "Proxy:"
      Height          =   285
      Left            =   120
      TabIndex        =   8
      Top             =   630
      Width           =   1005
   End
   Begin VB.Label lblAccessType 
      Caption         =   "Access type:"
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   1125
   End
End
Attribute VB_Name = "FConnectDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' ***************************************************************************************
' Declarations
' ***************************************************************************************

' Encaps
Private m_InetConnection As CInetConnection
Private m_Cancelled As Boolean


' ***************************************************************************************
' Init/Fin
' ***************************************************************************************
Public Sub Create(ByVal ic As CInetConnection)
On Error GoTo hell
    Set m_InetConnection = ic
    Exit Sub
hell:
End Sub
Private Sub Form_Load()
On Error GoTo hell
    cboAccessType.AddItem "Default": cboAccessType.ItemData(0) = InternetAccessTypes.PreConfig
    cboAccessType.AddItem "Default (no scripts)": cboAccessType.ItemData(1) = InternetAccessTypes.PreConfigWithNoAutoProxy
    cboAccessType.AddItem "Direct": cboAccessType.ItemData(2) = InternetAccessTypes.Direct
    cboAccessType.AddItem "Use Proxy": cboAccessType.ItemData(3) = InternetAccessTypes.Proxy
    Select Case m_InetConnection.AccessType
        Case InternetAccessTypes.PreConfig
            cboAccessType.ListIndex = 0
        Case InternetAccessTypes.PreConfigWithNoAutoProxy
            cboAccessType.ListIndex = 1
        Case InternetAccessTypes.Direct
            cboAccessType.ListIndex = 2
        Case InternetAccessTypes.Proxy
            cboAccessType.ListIndex = 3
    End Select
    txtProxy.Text = m_InetConnection.Proxy
    txtBypassProxy.Text = m_InetConnection.ProxyBypass
    If (m_InetConnection.AccessFlags And InternetAccessFlags.Async) > 0 Then chkAsync.Value = vbChecked Else chkAsync.Value = vbUnchecked
    If (m_InetConnection.AccessFlags And InternetAccessFlags.FromCache) > 0 Then chkFromCache.Value = vbChecked Else chkFromCache.Value = vbUnchecked
    UIHandleAccessTypeChanged
    Exit Sub
hell:
End Sub
Private Sub cmdOK_Click()
On Error GoTo hell
    If cboAccessType.ListIndex = 3 And txtProxy.Text = "" Then
        MsgBox "You need to name a proxy server, or choose another access type.", vbInformation, "Proxy information needed"
        txtProxy.SetFocus
        Exit Sub
    End If
    Select Case cboAccessType.ListIndex
        Case 0
            m_InetConnection.AccessType = InternetAccessTypes.PreConfig
        Case 1
            m_InetConnection.AccessType = InternetAccessTypes.PreConfigWithNoAutoProxy
        Case 2
            m_InetConnection.AccessType = InternetAccessTypes.Direct
        Case 3
            m_InetConnection.AccessType = InternetAccessTypes.Proxy
    End Select
    m_InetConnection.Proxy = txtProxy.Text
    m_InetConnection.ProxyBypass = txtBypassProxy.Text
    m_InetConnection.AccessFlags = 0
    If chkAsync.Value = vbChecked Then
        m_InetConnection.AccessFlags = m_InetConnection.AccessFlags Or InternetAccessFlags.Async
    End If
    If chkFromCache.Value = vbChecked Then
        m_InetConnection.AccessFlags = m_InetConnection.AccessFlags Or InternetAccessFlags.FromCache
    End If
    m_Cancelled = False
    Unload Me
    Set FConnectDialog = Nothing
    Exit Sub
hell:
End Sub
Private Sub cmdCancel_Click()
On Error GoTo hell
    m_Cancelled = True
    Unload Me
    Set FConnectDialog = Nothing
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Handlers
' ***************************************************************************************
Private Sub cboAccessType_Change()
On Error GoTo hell
    UIHandleAccessTypeChanged
    Exit Sub
hell:
End Sub
Private Sub cboAccessType_Click()
On Error GoTo hell
    UIHandleAccessTypeChanged
    Exit Sub
hell:
End Sub
Private Sub UIHandleAccessTypeChanged()
On Error GoTo hell
    Dim fEnableProxies As Boolean: fEnableProxies = (cboAccessType.ListIndex = 3)
    lblProxy.Enabled = fEnableProxies
    lblBypassProxy.Enabled = fEnableProxies
    txtProxy.Enabled = fEnableProxies
    txtBypassProxy.Enabled = fEnableProxies
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Properties
' ***************************************************************************************
Public Property Get Cancelled() As Boolean
On Error GoTo hell
    Cancelled = m_Cancelled
    Exit Property
hell:
End Property

