VERSION 5.00
Begin VB.Form FServersDialog 
   BorderStyle     =   4  'Festes Werkzeugfenster
   Caption         =   "FTP servers"
   ClientHeight    =   4515
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   8025
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4515
   ScaleWidth      =   8025
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'Fenstermitte
   Begin VB.Frame frmDetails 
      Caption         =   "Details:"
      Height          =   3765
      Left            =   2910
      TabIndex        =   4
      Top             =   120
      Width           =   4965
      Begin VB.ComboBox cboPort 
         Height          =   315
         ItemData        =   "FServersDialog.frx":0000
         Left            =   1230
         List            =   "FServersDialog.frx":0007
         TabIndex        =   10
         Top             =   1950
         Width           =   735
      End
      Begin VB.TextBox txtFriendlyName 
         Height          =   315
         Left            =   1230
         TabIndex        =   6
         Top             =   300
         Width           =   3555
      End
      Begin VB.CommandButton cmdUserInfo 
         Caption         =   "User info ..."
         Height          =   315
         Left            =   3810
         TabIndex        =   11
         Top             =   3240
         Width           =   1005
      End
      Begin VB.TextBox txtHost 
         Height          =   315
         Left            =   1230
         TabIndex        =   9
         Top             =   1500
         Width           =   3555
      End
      Begin VB.TextBox txtDescription 
         Height          =   675
         Left            =   1230
         MultiLine       =   -1  'True
         TabIndex        =   7
         Top             =   720
         Width           =   3555
      End
      Begin VB.Label lblPort 
         Caption         =   "Port:"
         Height          =   255
         Left            =   150
         TabIndex        =   15
         Top             =   2040
         Width           =   705
      End
      Begin VB.Label lblFriendlyName 
         Caption         =   "Name:"
         Height          =   225
         Left            =   150
         TabIndex        =   13
         Top             =   300
         Width           =   945
      End
      Begin VB.Label lblHost 
         Caption         =   "Host:"
         Height          =   255
         Left            =   150
         TabIndex        =   8
         Top             =   1530
         Width           =   885
      End
      Begin VB.Label lblDescription 
         Caption         =   "Description:"
         Height          =   255
         Left            =   150
         TabIndex        =   5
         Top             =   720
         Width           =   975
      End
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      Height          =   315
      Left            =   4740
      TabIndex        =   12
      Top             =   4080
      Width           =   1395
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "Close"
      Height          =   315
      Left            =   6420
      TabIndex        =   14
      Top             =   4080
      Width           =   1425
   End
   Begin VB.Frame frmServers 
      Caption         =   "Servers:"
      Height          =   3735
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2565
      Begin VB.CommandButton cmdRemoveServer 
         Caption         =   "Remove"
         Height          =   315
         Left            =   1350
         TabIndex        =   3
         Top             =   3240
         Width           =   1005
      End
      Begin VB.CommandButton cmdAddServer 
         Caption         =   "Add ..."
         Height          =   315
         Left            =   180
         TabIndex        =   2
         Top             =   3240
         Width           =   1005
      End
      Begin VB.ListBox lstServers 
         Height          =   2790
         Left            =   150
         TabIndex        =   1
         Top             =   300
         Width           =   2235
      End
   End
End
Attribute VB_Name = "FServersDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' ***************************************************************************************
' Declarations
' ***************************************************************************************

' Encaps
Private m_Servers As NFtpServers
Private m_SelectedServer As CFtpServer
Private m_ReadingDetails As Boolean
Private m_AllowConnect As Boolean


' ***************************************************************************************
' Init
' ***************************************************************************************
Public Sub Create(ByVal servers As NFtpServers, ByVal fAllowConnect As Boolean)
On Error GoTo hell
    Set m_Servers = servers
    m_AllowConnect = fAllowConnect
    Exit Sub
hell:
End Sub
Private Sub Form_Load()
On Error GoTo hell
    UIReadServers
    Exit Sub
hell:
End Sub
Private Sub cmdConnect_Click()
On Error GoTo hell
    If InetConnection.AttemptConnect = True Then
        cmdClose_Click
        m_SelectedServer.Connect
    End If
    Exit Sub
hell:
End Sub
Private Sub cmdClose_Click()
On Error GoTo hell
    Set m_SelectedServer = GetServer
    Unload Me
    Set FServersDialog = Nothing
    Exit Sub
hell:
End Sub
Public Property Get SelectedServer() As CFtpServer
On Error GoTo hell
    Set SelectedServer = m_SelectedServer
    Exit Property
hell:
End Property


' ***************************************************************************************
' Handlers
' ***************************************************************************************
Private Sub lstServers_Click()
On Error GoTo hell
    UIReadDetails
    Exit Sub
hell:
End Sub
Private Sub cmdAddServer_Click()
On Error GoTo hell
    Dim sFriendlyName As String, sHost As String, locator As New CUrl, server As CFtpServer
    sFriendlyName = InputBox("Please enter a name for the new server:", "New server - name")
    If sFriendlyName <> "" Then
        sHost = InputBox("Please enter the host address:", "New server - host", "ftp.myserver.com")
        If sHost <> "" Then
            locator.CreateFromComponents "ftp", sHost, , , , , InternetPorts.DefaultFtp
            Set server = m_Servers.AddFromUrl(locator)
            server.FriendlyName = sFriendlyName
            UIReadServers
            lstServers.ListIndex = m_Servers.Count - 1
        End If
    End If
    Exit Sub
hell:
    If Err.Number And InternetErrors.FtpServerHostNotUnique Then
        MsgBox "The FTP host " & Chr$(34) & sHost & Chr$(34) & " already exists.", vbExclamation, "Host already exists"
    End If
End Sub
Private Sub cmdRemoveServer_Click()
On Error GoTo hell
    m_Servers.Remove GetServer.Url.Host
    UIReadServers
    Exit Sub
hell:
End Sub
Private Sub txtFriendlyName_Change()
On Error GoTo hell
    If m_ReadingDetails = False Then UIUpdateListEntry
    Exit Sub
hell:
End Sub
Private Sub txtDescription_Change()
On Error GoTo hell
    If m_ReadingDetails = False Then UIUpdateListEntry
    Exit Sub
hell:
End Sub
Private Sub txtHost_Change()
On Error GoTo hell
    If m_ReadingDetails = False Then UIUpdateListEntry
    Exit Sub
hell:
End Sub
Private Sub cboPort_Click()
On Error GoTo hell
    cboPort_Change
    Exit Sub
hell:
End Sub
Private Sub cboPort_Change()
On Error GoTo hell
    If m_ReadingDetails = False Then
        If Not IsNumeric(CVar(cboPort.Text)) Then cboPort.Text = 21
        UIUpdateListEntry
    End If
    Exit Sub
hell:
End Sub
Private Sub cmdUserInfo_Click()
On Error GoTo hell
    GetServer.Url.ShowUserDialog
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Helpers
' ***************************************************************************************
Private Sub UIReadServers()
On Error GoTo hell
    lstServers.Clear
    Dim server As CFtpServer, sListText As String
    For Each server In m_Servers
        sListText = "(" & server.Url.Host & ")"
        If server.FriendlyName <> "" Then
            sListText = server.FriendlyName & " " & sListText
        End If
        lstServers.AddItem sListText
    Next server
    UIReadDetails
    Exit Sub
hell:
End Sub
Private Sub UIReadDetails()
On Error GoTo hell
    ' ui
    Dim fEnabled As Boolean: fEnabled = (lstServers.ListIndex > -1)
    cmdRemoveServer.Enabled = fEnabled
    frmDetails.Enabled = fEnabled
    lblFriendlyName.Enabled = fEnabled
    lblDescription.Enabled = fEnabled
    lblHost.Enabled = fEnabled
    lblPort.Enabled = fEnabled
    txtFriendlyName.Enabled = fEnabled
    txtDescription.Enabled = fEnabled
    txtHost.Enabled = fEnabled
    cboPort.Enabled = fEnabled
    cmdUserInfo.Enabled = fEnabled
    cmdConnect.Enabled = fEnabled And m_AllowConnect
    ' ...
    ' block handlers
    m_ReadingDetails = True
    ' reset
    txtFriendlyName.Text = ""
    txtDescription.Text = ""
    txtHost.Text = ""
    cboPort.Text = ""
    ' data
    Dim server As CFtpServer
    Set server = GetServer
    txtFriendlyName.Text = server.FriendlyName
    txtDescription.Text = server.Description
    txtHost.Text = server.Url.Host
    cboPort.Text = CStr(server.Url.Port)
    ' ...
    ' re-enable handlers
    m_ReadingDetails = False
    Exit Sub
hell:
End Sub
Private Sub UIUpdateListEntry()
On Error GoTo hell
    ' some vars
    Dim server As CFtpServer: Set server = GetServer
    With server.Url
        Dim sUserName As String: sUserName = vbNullString: If Not .CurrentUser Is Nothing Then sUserName = .CurrentUser.UserName
        Dim sPassword As String: sPassword = vbNullString: If Not .CurrentUser Is Nothing Then sPassword = .CurrentUser.Password
        .CreateFromComponents .SchemeName, txtHost.Text, .Path, sUserName, sPassword, .ExtraInfo, .Port
    End With
    ' update objects
    If txtFriendlyName.Text <> "" Then
        server.FriendlyName = txtFriendlyName.Text
    End If
    If txtDescription.Text <> "" Then
        server.Description = txtDescription.Text
    End If
    If txtHost.Text <> "" Then
        With server.Url
            .CreateFromComponents .SchemeName, txtHost.Text, .Path, sUserName, sPassword, .ExtraInfo, .Port
        End With
    End If
    If cboPort.Text <> "" And IsNumeric(CVar(cboPort.Text)) Then
        With server.Url
            .CreateFromComponents .SchemeName, .Host, .Path, sUserName, sPassword, .ExtraInfo, CLng(cboPort.Text)
        End With
    End If
    ' list
    Dim sListText As String: sListText = "(" & server.Url.Host & ")"
    If server.FriendlyName <> "" Then sListText = server.FriendlyName & " " & sListText
    lstServers.List(lstServers.ListIndex) = sListText
    Exit Sub
hell:
End Sub
Private Function GetServer() As CFtpServer
On Error GoTo hell
    Set GetServer = m_Servers(lstServers.ListIndex + 1)
    Exit Function
hell:
End Function
