VERSION 5.00
Begin VB.Form FUserDialog 
   BorderStyle     =   4  'Festes Werkzeugfenster
   Caption         =   "User name and password"
   ClientHeight    =   1845
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   5565
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1845
   ScaleWidth      =   5565
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'Fenstermitte
   Begin VB.ComboBox cboUserName 
      Height          =   315
      Left            =   1350
      TabIndex        =   1
      Top             =   180
      Width           =   2655
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   315
      Left            =   4320
      TabIndex        =   8
      Top             =   630
      Width           =   1095
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   315
      Left            =   4320
      TabIndex        =   7
      Top             =   180
      Width           =   1095
   End
   Begin VB.CheckBox chkSavePassword 
      Caption         =   "Save password"
      Height          =   285
      Left            =   1680
      TabIndex        =   6
      Top             =   1470
      Width           =   1695
   End
   Begin VB.CheckBox chkSaveUserName 
      Caption         =   "Save user name"
      Height          =   255
      Left            =   1350
      TabIndex        =   5
      Top             =   1140
      Width           =   1905
   End
   Begin VB.TextBox txtPassword 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   1350
      PasswordChar    =   "*"
      TabIndex        =   3
      Top             =   630
      Width           =   2655
   End
   Begin VB.Label lblSave 
      Caption         =   "Save:"
      Height          =   315
      Left            =   120
      TabIndex        =   4
      Top             =   1080
      Width           =   855
   End
   Begin VB.Label lblPassword 
      Caption         =   "Password:"
      Height          =   285
      Left            =   120
      TabIndex        =   2
      Top             =   630
      Width           =   1095
   End
   Begin VB.Label lblUserName 
      Caption         =   "User name:"
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   1005
   End
End
Attribute VB_Name = "FUserDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' ***************************************************************************************
' Declarations
' ***************************************************************************************

' Encaps
Private m_Url As CUrl
Private m_Cancelled As Boolean


' ***************************************************************************************
' Init
' ***************************************************************************************
Public Sub Create(ByVal locator As CUrl)
On Error GoTo hell
    Set m_Url = locator
    Init
    Exit Sub
hell:
End Sub
Private Sub Init()
On Error GoTo hell
    ' initial data
    Dim usr As CUser
    For Each usr In m_Url.Users
        cboUserName.AddItem usr.UserName
    Next usr
    If Not m_Url.CurrentUser Is Nothing Then
        cboUserName.Text = m_Url.CurrentUser.UserName
    End If
    UpdateUINameChange
    Exit Sub
hell:
End Sub
Public Property Get Cancelled() As Boolean
On Error GoTo hell
    Cancelled = m_Cancelled
    Exit Property
hell:
End Property


' ***************************************************************************************
' Handlers
' ***************************************************************************************
Private Sub cmdOK_Click()
On Error GoTo hell
    m_Url.SetCurrentUser cboUserName.Text, txtPassword.Text, (chkSaveUserName.Value = vbChecked), (chkSavePassword.Value = vbChecked)
    m_Cancelled = False
    Set m_Url = Nothing
    Unload Me
    Set FUserDialog = Nothing
    Exit Sub
hell:
End Sub
Private Sub cmdCancel_Click()
On Error GoTo hell
    m_Cancelled = True
    Set m_Url = Nothing
    Unload Me
    Set FUserDialog = Nothing
    Exit Sub
hell:
End Sub
Private Sub cboUserName_Click()
On Error GoTo hell
    UpdateUINameChange
    Exit Sub
hell:
End Sub
Private Sub cboUserName_Change()
On Error GoTo hell
    UpdateUINameChange
    Exit Sub
hell:
End Sub
Private Sub txtPassword_Change()
On Error GoTo hell
    UpdateUIPasswordChange
    Exit Sub
hell:
End Sub
Private Sub chkSaveUserName_Click()
On Error GoTo hell
    UpdateUIPasswordChange
    Exit Sub
hell:
End Sub
Private Sub UpdateUINameChange()
On Error GoTo hell
    Dim sUserName As String: sUserName = cboUserName.Text
    If m_Url.Users.Exists(sUserName) Then
                txtPassword.Text = m_Url.Users(sUserName).Password
                If m_Url.Users(sUserName).PersistUserName = True Then
                            chkSaveUserName.Value = vbChecked
                    Else:   chkSaveUserName.Value = vbUnchecked
                End If
        Else
                txtPassword.Text = ""
                chkSaveUserName.Value = vbUnchecked
    End If
    chkSaveUserName.Enabled = (sUserName <> "")
    UpdateUIPasswordChange
    Exit Sub
hell:
End Sub
Private Sub UpdateUIPasswordChange()
On Error GoTo hell
    chkSavePassword.Enabled = (txtPassword.Text <> "" And chkSaveUserName.Enabled And chkSaveUserName.Value = vbChecked)
    If chkSavePassword.Enabled = True Then
                Dim sUserName As String: sUserName = cboUserName.Text
                If m_Url.Users.Exists(sUserName) Then
                    If m_Url.Users(sUserName).PersistPassword = True Then
                                chkSavePassword.Value = vbChecked
                        Else:   chkSavePassword.Value = vbUnchecked
                    End If
                End If
        Else
                chkSavePassword.Value = vbUnchecked
    End If
    Exit Sub
hell:
End Sub


