VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "GGlobals"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit


' ***************************************************************************************
' Constants
' ***************************************************************************************
Public Enum InternetStates
    ResolvingName = 10
    NameResolved = 11
    ConnectingToServer = 20
    ConnectedToServer = 21
    SendingRequest = 30
    RequestSent = 31
    ReceivingResponse = 40
    ResponseReceived = 41
    CtlResponseReceived = 42
    PreFetch = 43
    ClosingConnection = 50
    ConnectionClosed = 51
    HandleCreated = 60
    HandleClosing = 70
    RequestComplete = 100
    Redirect = 110
    IntermediateResponse = 120
    StateChange = 200
End Enum
Public Enum InternetStateChangeValues
    Connected = &H1
    Disconnected = &H2
    DisconnectedByUser = &H10
    Idle = &H100
    Busy = &H200
End Enum
Public Enum InternetAccessTypes
    PreConfig = 0
    Direct = 1
    Proxy = 3
    PreConfigWithNoAutoProxy = 4
End Enum
Public Enum InternetAccessFlags
    None = &H0
    Async = &H10000000
    FromCache = &H1000000
    Offline = FromCache
End Enum
Public Enum InternetPorts
    Invalid = 0     ' use protocol-specific default
    DefaultFtp = 21
    DefaultGopher = 70
    DefaultHttp = 80
    DefaultHttps = 443
    DefaultSocks = 1080
End Enum
Public Enum InternetServices
    Url = 0
    Ftp = 1
    Gopher = 2
    Http = 3
End Enum
Public Enum InternetSchemes
    Partial = -2
    Unknown = -1
    [Default] = 0
    Ftp = 1
    Gopher = 2
    Http = 3
    Https = 4
    file = 5
    News = 6
    Mailto = 7
    First = Ftp
    Last = Mailto
End Enum
Public Enum InternetCrackUrlFlags
    Decode = &H10000000
    Escape = &H80000000
End Enum
Public Enum InternetCreateUrlFlags
    Escape = &H80000000
    UserName = &H40000000
End Enum
Public Enum FileAttributes
    Archive = &H20
    Compressed = &H800
    Directory = &H10
    Encrypted = &H40
    Hidden = &H2
    Normal = &H80
    Offline = &H1000
    ReadOnly = &H1
    ReparsePoint = &H400
    SparseFile = &H200
    System = &H4
    Temporary = &H100
End Enum
Public Enum InternetFlags ' kitchensink
    None = 0
    Passive = &H8000000
    NoCacheWrite = &H4000000
    Reload = &H80000000
    ExistingConnect = &H20000000
    TransferAscii = &H1
    TransferBinary = &H2
End Enum
Public Enum InternetErrors
    InternetNotConnected
    InternetServicesInaccessible
    InternetBadProxyConfig
    FtpServerNotConnected
    FtpServerHostNotUnique
    FtpServerInvalidProtocol
    UrlUserNameNeeded
    FtpFolderOperationFailed
End Enum
Public Enum FtpTransferModes
    Unknown = &H0
    Ascii = &H1
    Binary = &H2
End Enum
Public Enum FtpFileAccessModes
    GenericRead = &H80000000
    GenericWrite = &H40000000
End Enum


' ***************************************************************************************
' Global properties
' ***************************************************************************************
Public Property Get InetConnection() As CInetConnection
On Error GoTo hell
    Set InetConnection = MInet.InetConnection
    Exit Property
hell:
End Property
