VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CUrl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' ***************************************************************************************
' Declarations
' ***************************************************************************************

' Encaps
Private m_Value As String
Private m_Scheme As InternetSchemes
Private m_SchemeName As String
Private m_Host As String
Private m_Path As String
Private m_CurrentUser As CUser
Private m_ExtraInfo As String
Private m_Port As InternetPorts
Private m_Users As NUsers


' ***************************************************************************************
' Init/Fin
' ***************************************************************************************
Private Sub Class_Initialize()
On Error GoTo hell
    Set m_Users = New NUsers
    Exit Sub
hell:
End Sub
Public Sub CreateFromComponents(ByVal sSchemeName As String, ByVal sHost As String, _
                                    Optional ByVal sPath As String = vbNullString, _
                                    Optional ByVal sUserName As String = vbNullString, _
                                    Optional ByVal sPassword As String = vbNullString, _
                                    Optional ByVal sExtraInfo As String = vbNullString, _
                                    Optional ByVal nPort As InternetPorts = InternetPorts.Invalid)
On Error GoTo hell
    ' create
    DoCreateFromComponents sSchemeName, sHost, sPath, sUserName, sPassword, sExtraInfo, nPort
    Exit Sub
hell:
End Sub
Public Sub CreateFromString(ByVal sUrl As String)
On Error GoTo hell
    DoCreateFromCrack (sUrl)
    Exit Sub
hell:
End Sub
Friend Sub CreateFromXmlNode(ByVal xn As CXMLNode)
On Error GoTo hell
    Dim usr As CUser, xnSub As CXMLNode
    For Each xnSub In xn.SubNodes
        If xnSub.Name = "user" Then
            Set usr = m_Users.Add(xnSub.Attributes("username").Value, xnSub.Attributes("password").Value, True)
            If usr.Password <> "" Then
                usr.SetPersistPassword True
            End If
        End If
    Next xnSub
    With xn.Attributes
        DoCreateFromComponents .Item("schemename").Value, .Item("host").Value, .Item("path").Value, , , .Item("extrainfo").Value, CLng(.Item("port").Value)
        If .Item("currentuser").Value <> "" Then
            Set m_CurrentUser = m_Users(.Item("currentuser").Value)
        End If
    End With
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Properties
' ***************************************************************************************
Public Property Get Value() As String
On Error GoTo hell
        Value = m_Value
    Exit Property
hell:
End Property
Public Property Get Scheme() As InternetSchemes
On Error GoTo hell
    Scheme = m_Scheme
    Exit Sub
hell:
End Property
Public Property Get SchemeName() As String
On Error GoTo hell
    SchemeName = m_SchemeName
    Exit Sub
hell:
End Property
Public Property Get Host() As String
On Error GoTo hell
    Host = m_Host
    Exit Sub
hell:
End Property
Public Property Get Path() As String
On Error GoTo hell
    Path = m_Path
    Exit Sub
hell:
End Property
Public Property Get Port() As InternetPorts
On Error GoTo hell
    Port = m_Port
    Exit Sub
hell:
End Property
Public Property Get CurrentUser() As CUser
On Error GoTo hell
    Set CurrentUser = m_CurrentUser
    Exit Sub
hell:
End Property
Public Property Get ExtraInfo() As String
On Error GoTo hell
    ExtraInfo = m_ExtraInfo
    Exit Sub
hell:
End Property
Public Property Get Users() As NUsers
On Error GoTo hell
    Set Users = m_Users
    Exit Sub
hell:
End Property


' ***************************************************************************************
' Methods
' ***************************************************************************************
Public Function ShowUserDialog() As Boolean
On Error GoTo hell
    Dim ud As FUserDialog
    Set ud = New FUserDialog
    ud.Create Me
    ud.Show vbModal
    Unload ud
    ShowUserDialog = Not ud.Cancelled
    Exit Function
hell:
End Function
Public Sub SetCurrentUser(ByVal sUserName As String, ByVal sPassword As String, _
                          ByVal fPersistUserName As Boolean, ByVal fPersistPassword As Boolean)
On Error GoTo hell
    ' create url (set/add user)
    CreateFromComponents m_SchemeName, m_Host, m_Path, _
                            sUserName, sPassword, _
                            m_ExtraInfo, m_Port
    ' other props
    If Not m_CurrentUser Is Nothing Then
        m_CurrentUser.SetPersistUserName fPersistUserName
        m_CurrentUser.SetPersistPassword fPersistPassword
    End If
    Exit Sub
hell:
End Sub
Friend Sub Persist(ByVal xnParent As CXMLNode)
On Error GoTo hell
    Dim xn As CXMLNode, usr As CUser, sCurrentUser As String
    Set xn = xnParent.SubNodes.Add("url")
    xn.Attributes.Add "schemename", m_SchemeName
    xn.Attributes.Add "host", m_Host
    xn.Attributes.Add "port", m_Port
    xn.Attributes.Add "path", m_Path
    xn.Attributes.Add "extrainfo", m_ExtraInfo
    If Not m_CurrentUser Is Nothing Then
        If m_CurrentUser.PersistUserName = True Then
           sCurrentUser = m_CurrentUser.UserName
        End If
    End If
    xn.Attributes.Add "currentuser", sCurrentUser
    For Each usr In m_Users
        usr.Persist xn
    Next usr
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Helpers
' ***************************************************************************************
Private Sub DoCreateFromComponents(ByVal sSchemeName As String, ByVal sHost As String, _
                                    Optional ByVal sPath As String = vbNullString, _
                                    Optional ByVal sUserName As String = vbNullString, _
                                    Optional ByVal sPassword As String = vbNullString, _
                                    Optional ByVal sExtraInfo As String = vbNullString, _
                                    Optional ByVal nPort As InternetPorts = InternetPorts.Invalid)
On Error GoTo hell
    Dim uc As TUrlComponents
    uc.szScheme = sSchemeName
    uc.dwSchemeLength = Len(uc.szScheme)
    uc.szHostName = sHost
    uc.dwHostNameLength = Len(uc.szHostName)
    uc.szUrlPath = sPath
    If uc.szUrlPath <> vbNullString Then uc.dwUrlPathLength = Len(uc.szUrlPath)
    uc.szUserName = sUserName
    If uc.szUserName <> vbNullString Then uc.dwUserNameLength = Len(uc.szUserName)
    uc.szPassword = sPassword
    If uc.szPassword <> vbNullString Then uc.dwPasswordLength = Len(uc.szPassword)
    uc.szExtraInfo = sExtraInfo
    If uc.szExtraInfo <> vbNullString Then uc.dwExtraInfoLength = Len(uc.szExtraInfo)
    uc.nPort = nPort
    uc.dwStructSize = LenB(uc)
    Dim sUrl As String: sUrl = String$(2048, Chr(0))
    Dim dwLength As Long: dwLength = Len(sUrl)
    If CBool(InternetCreateUrl(uc, InternetCreateUrlFlags.Escape, sUrl, dwLength)) = True Then
        DoCreateFromCrack (sUrl)
    End If
    Exit Sub
hell:
End Sub
Private Sub DoCreateFromCrack(ByVal sUrl As String)
On Error GoTo hell
    Dim uc As TUrlComponents
    uc.nScheme = InternetSchemes.Default
    uc.szScheme = String$(20, Chr(0))
    uc.dwSchemeLength = Len(uc.szScheme)
    uc.szHostName = String$(120, Chr(0))
    uc.dwHostNameLength = Len(uc.szHostName)
    uc.szUrlPath = String$(260, Chr(0))
    uc.dwUrlPathLength = Len(uc.szUrlPath)
    uc.szUserName = String$(40, Chr(0))
    uc.dwUserNameLength = Len(uc.szUserName)
    uc.szPassword = String$(40, Chr(0))
    uc.dwPasswordLength = Len(uc.szPassword)
    uc.szExtraInfo = String$(260, Chr(0))
    uc.dwExtraInfoLength = Len(uc.szExtraInfo)
    uc.dwStructSize = LenB(uc)
    If CBool(InternetCrackUrl(sUrl, Len(sUrl), InternetCrackUrlFlags.Escape, uc)) = True Then
        m_Value = NullTrim(sUrl)
        m_Scheme = uc.nScheme
        m_SchemeName = NullTrim(uc.szScheme)
        m_Path = NullTrim(uc.szUrlPath)
        m_Host = NullTrim(uc.szHostName)
        m_ExtraInfo = NullTrim(uc.szExtraInfo)
        m_Port = uc.nPort
        Dim sUserName As String: sUserName = NullTrim(uc.szUserName)
        Dim sPassword As String: sPassword = NullTrim(uc.szPassword)
        If sUserName = "" Then
                    Set m_CurrentUser = Nothing
            ElseIf m_Users.Exists(sUserName) Then
                    Set m_CurrentUser = m_Users(sUserName)
                    m_CurrentUser.SetPassword sPassword
            Else
                    Set m_CurrentUser = m_Users.Add(sUserName, sPassword)
        End If
    End If
    Exit Sub
hell:
End Sub



