VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "NFtpServers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' ***************************************************************************************
' Declarations
' ***************************************************************************************

' Encaps
Private m_Col As New Collection


' ***************************************************************************************
' Init/Fin
' ***************************************************************************************
Private Sub Class_Initialize()
On Error GoTo hell
    Set m_Col = New Collection
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Methods
' ***************************************************************************************
Public Function AddFromUrl(ByVal locator As CUrl) As CFtpServer
    If Me.Exists(locator.Host) Then InternetRaiseError FtpServerHostNotUnique
    Dim server As New CFtpServer
    server.CreateFromUrl locator
On Error GoTo hell
    server.SetParentInetConnedtion MInet.InetConnection
    m_Col.Add server, server.Url.Host
    Set AddFromUrl = server
    Exit Function
hell:
End Function
Public Function AddFromData(ByVal sHost As String, Optional ByVal sPath As String = "", Optional ByVal sUserName As String = "", Optional ByVal sPassword As String = "") As CFtpServer
    Dim locator As New CUrl
    locator.CreateFromComponents "ftp", sHost, sPath, sUserName, sPassword, "", DefaultFtp
    Set AddFromData = Me.AddFromUrl(locator)
End Function
Public Function AddFromXmlNode(ByVal xn As CXMLNode) As CFtpServer
On Error GoTo hell
    Dim server As CFtpServer: Set server = New CFtpServer
    server.CreateFromXmlNode xn
    If Me.Exists(server.Url.Host) Then
        On Error GoTo 0
        InternetRaiseError FtpServerHostNotUnique
    Else
        server.SetParentInetConnedtion MInet.InetConnection
        m_Col.Add server, server.Url.Host
        Set AddFromXmlNode = server
    End If
    Exit Function
hell:
End Function
Public Sub Remove(ByVal vIndex As Variant)
On Error GoTo hell
    m_Col.Remove vIndex
    Exit Sub
hell:
End Sub
Public Sub Clear()
On Error GoTo hell
    Do While m_Col.Count > 0
        m_Col.Remove 1
    Loop
    Exit Sub
hell:
End Sub
Public Function Exists(ByVal vIndex As Variant) As Boolean
On Error GoTo hell
    Dim server As CFtpServer
    Set server = Me.Item(vIndex)
    Exists = Not (server Is Nothing)
    Exit Function
hell:
End Function
Public Function Find(ByVal sFullUrl As String) As CFtpServer
On Error GoTo hell
    Dim locator As New CUrl
    locator.CreateFromString sFullUrl
    Set Find = Me.Item(locator.Host)
    Exit Function
hell:
End Function


' ***************************************************************************************
' Element access
' ***************************************************************************************
Public Property Get Count() As Long
On Error GoTo hell
    Count = m_Col.Count
    Exit Property
hell:
End Property
Public Property Get Item(ByVal vIndex As Variant) As CFtpServer ' def
Attribute Item.VB_UserMemId = 0
On Error GoTo hell
    Set Item = m_Col(vIndex)
    Exit Property
hell:
End Property
Public Function GetEnumerator() As IEnumVARIANT ' -4
Attribute GetEnumerator.VB_UserMemId = -4
On Error GoTo hell
    Set GetEnumerator = m_Col.[_NewEnum]
    Exit Function
hell:
End Function

